 


//--AgentGen BEGIN=_BEGIN
//--AgentGen END

#ifndef _entity_mib_cpp
#define  _entity_mib_cpp

#include <agent_pp/agent++.h>
#include <entity_mib.h>
#include <module_includes.h>

//--AgentGen BEGIN=_INCLUDE
//--AgentGen END


#ifdef SNMP_PP_NAMESPACE
using namespace Snmp_pp;
#endif

#ifdef AGENTPP_NAMESPACE
namespace Agentpp {
#endif


static const char *agenProLogModule = "entity_mib";

//--AgentGen BEGIN=_UTIL_CLASSES
//--AgentGen END

// Scalar Objects


/**
 *  entLastChangeTime
 *
 * "The value of sysUpTime at the time a conceptual row is
 * created, modified, or deleted in any of these tables:
 *         - entPhysicalTable
 *         - entLogicalTable
 *         - entLPMappingTable
 *         - entAliasMappingTable
 *         - entPhysicalContainsTable

 * "
 */
 
entity_mib_entLastChangeTime* entity_mib_entLastChangeTime::instance = 0;


entity_mib_entLastChangeTime::entity_mib_entLastChangeTime():
    MibLeaf(oid_ENTITY_MIB_EntLastChangeTime, READONLY, new NS_SNMP TimeTicks()){
	// This leaf object is a singleton. In order to access it use
	// the static pointer entity_mib_entLastChangeTime::instance.
	instance = this;
	//--AgentGen BEGIN=entLastChangeTime::entity_mib_entLastChangeTime
	//--AgentGen END

}

entity_mib_entLastChangeTime::~entity_mib_entLastChangeTime()
{

	//--AgentGen BEGIN=entLastChangeTime::~entity_mib_entLastChangeTime
	//--AgentGen END

	// clear singleton reference
	entity_mib_entLastChangeTime::instance = 0;
}

void entity_mib_entLastChangeTime::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entLastChangeTime::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

unsigned long entity_mib_entLastChangeTime::get_state()
{
	//--AgentGen BEGIN=entLastChangeTime::get_state
	//--AgentGen END
	return (unsigned long)*((NS_SNMP TimeTicks*)value);
}

void entity_mib_entLastChangeTime::set_state(unsigned long l)
{
	//--AgentGen BEGIN=entLastChangeTime::set_state
	//--AgentGen END
	*((NS_SNMP TimeTicks*)value) = l;
}


//--AgentGen BEGIN=entLastChangeTime
//--AgentGen END



// Columnar Objects


/**
 *  entPhysicalSerialNum
 *
 * "The vendor-specific serial number string for the physical
 * entity.  The preferred value is the serial number string
 * actually printed on the component itself (if present).

 * On the first instantiation of a physical entity, the value
 * of entPhysicalSerialNum associated with that entity is set
 * to the correct vendor-assigned serial number, if this
 * information is available to the agent.  If a serial number
 * is unknown or non-existent, the entPhysicalSerialNum will be
 * set to a zero-length string instead.




 * Note that implementations that can correctly identify the
 * serial numbers of all installed physical entities do not
 * need to provide write access to the entPhysicalSerialNum
 * object.  Agents that cannot provide non-volatile storage
 * for the entPhysicalSerialNum strings are not required to
 * implement write access for this object.

 * Not every physical component will have a serial number, or
 * even need one.  Physical entities for which the associated
 * value of the entPhysicalIsFRU object is equal to 'false(2)'
 * (e.g., the repeater ports within a repeater module) do not
 * need their own unique serial numbers.  An agent does not
 * have to provide write access for such entities and may
 * return a zero-length string.

 * If write access is implemented for an instance of
 * entPhysicalSerialNum and a value is written into the
 * instance, the agent must retain the supplied value in the
 * entPhysicalSerialNum instance (associated with the same
 * physical entity) for as long as that entity remains
 * instantiated.  This includes instantiations across all
 * re-initializations/reboots of the network management system,
 * including those resulting in a change of the physical
 * entity's entPhysicalIndex value."
 */
 
entity_mib_entPhysicalSerialNum::entity_mib_entPhysicalSerialNum(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP OctetStr()){
	//--AgentGen BEGIN=entPhysicalSerialNum::entity_mib_entPhysicalSerialNum
	//--AgentGen END

}

entity_mib_entPhysicalSerialNum::~entity_mib_entPhysicalSerialNum()
{

	//--AgentGen BEGIN=entPhysicalSerialNum::~entity_mib_entPhysicalSerialNum
	//--AgentGen END

}

MibEntryPtr entity_mib_entPhysicalSerialNum::clone()
{
	MibEntryPtr other = new entity_mib_entPhysicalSerialNum(oid);
	((entity_mib_entPhysicalSerialNum*)other)->replace_value(value->clone());
	((entity_mib_entPhysicalSerialNum*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=entPhysicalSerialNum::clone
	//--AgentGen END
	return other;
}

void entity_mib_entPhysicalSerialNum::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalSerialNum::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

NS_SNMP OctetStr entity_mib_entPhysicalSerialNum::get_state() {
	//--AgentGen BEGIN=entPhysicalSerialNum::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void entity_mib_entPhysicalSerialNum::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=entPhysicalSerialNum::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int entity_mib_entPhysicalSerialNum::set(const Vbx& vb)
{
	//--AgentGen BEGIN=entPhysicalSerialNum::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int entity_mib_entPhysicalSerialNum::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalSerialNum::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=entPhysicalSerialNum::commit_set_request2
	//--AgentGen END
	return status;
}

void entity_mib_entPhysicalSerialNum::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalSerialNum::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int entity_mib_entPhysicalSerialNum::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalSerialNum::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool entity_mib_entPhysicalSerialNum::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=entPhysicalSerialNum::value_ok
	//--AgentGen END
	return TRUE;
}

int entity_mib_entPhysicalSerialNum::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	NS_SNMP Vb vb(req->get_value(ind));
	NS_SNMP OctetStr v;
	vb.get_value(v);
	if (!(((v.len() >= 0) && (v.len() <= 32))))
		 return SNMP_ERROR_WRONG_LENGTH;
	//--AgentGen BEGIN=entPhysicalSerialNum::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=entPhysicalSerialNum
//--AgentGen END




/**
 *  entPhysicalAlias
 *
 * "This object is an 'alias' name for the physical entity, as
 * specified by a network manager, and provides a non-volatile
 * 'handle' for the physical entity.

 * On the first instantiation of a physical entity, the value
 * of entPhysicalAlias associated with that entity is set to
 * the zero-length string.  However, the agent may set the
 * value to a locally unique default value, instead of a
 * zero-length string.

 * If write access is implemented for an instance of
 * entPhysicalAlias and a value is written into the instance,
 * the agent must retain the supplied value in the
 * entPhysicalAlias instance (associated with the same physical
 * entity) for as long as that entity remains instantiated.
 * This includes instantiations across all
 * re-initializations/reboots of the network management system,
 * including those resulting in a change of the physical
 * entity's entPhysicalIndex value."
 */
 
entity_mib_entPhysicalAlias::entity_mib_entPhysicalAlias(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP OctetStr()){
	//--AgentGen BEGIN=entPhysicalAlias::entity_mib_entPhysicalAlias
	//--AgentGen END

}

entity_mib_entPhysicalAlias::~entity_mib_entPhysicalAlias()
{

	//--AgentGen BEGIN=entPhysicalAlias::~entity_mib_entPhysicalAlias
	//--AgentGen END

}

MibEntryPtr entity_mib_entPhysicalAlias::clone()
{
	MibEntryPtr other = new entity_mib_entPhysicalAlias(oid);
	((entity_mib_entPhysicalAlias*)other)->replace_value(value->clone());
	((entity_mib_entPhysicalAlias*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=entPhysicalAlias::clone
	//--AgentGen END
	return other;
}

void entity_mib_entPhysicalAlias::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalAlias::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

NS_SNMP OctetStr entity_mib_entPhysicalAlias::get_state() {
	//--AgentGen BEGIN=entPhysicalAlias::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void entity_mib_entPhysicalAlias::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=entPhysicalAlias::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int entity_mib_entPhysicalAlias::set(const Vbx& vb)
{
	//--AgentGen BEGIN=entPhysicalAlias::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int entity_mib_entPhysicalAlias::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalAlias::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=entPhysicalAlias::commit_set_request2
	//--AgentGen END
	return status;
}

void entity_mib_entPhysicalAlias::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalAlias::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int entity_mib_entPhysicalAlias::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalAlias::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool entity_mib_entPhysicalAlias::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=entPhysicalAlias::value_ok
	//--AgentGen END
	return TRUE;
}

int entity_mib_entPhysicalAlias::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	NS_SNMP Vb vb(req->get_value(ind));
	NS_SNMP OctetStr v;
	vb.get_value(v);
	if (!(((v.len() >= 0) && (v.len() <= 32))))
		 return SNMP_ERROR_WRONG_LENGTH;
	//--AgentGen BEGIN=entPhysicalAlias::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=entPhysicalAlias
//--AgentGen END




/**
 *  entPhysicalAssetID
 *
 * "This object is a user-assigned asset tracking identifier
 * (as specified by a network manager) for the physical entity
 * and provides non-volatile storage of this information.

 * On the first instantiation of a physical entity, the value
 * of entPhysicalAssetID associated with that entity is set to
 * the zero-length string.

 * Not every physical component will have an asset tracking
 * identifier or even need one.  Physical entities for which
 * the associated value of the entPhysicalIsFRU object is equal
 * to 'false(2)' (e.g., the repeater ports within a repeater
 * module) do not need their own unique asset tracking
 * identifier.  An agent does not have to provide write access
 * for such entities and may instead return a zero-length
 * string.

 * If write access is implemented for an instance of
 * entPhysicalAssetID and a value is written into the
 * instance, the agent must retain the supplied value in the
 * entPhysicalAssetID instance (associated with the same
 * physical entity) for as long as that entity remains
 * instantiated.  This includes instantiations across all
 * re-initializations/reboots of the network management system,
 * including those resulting in a change of the physical
 * entity's entPhysicalIndex value.

 * If no asset tracking information is associated with the
 * physical component, then this object will contain a
 * zero-length string."
 */
 
entity_mib_entPhysicalAssetID::entity_mib_entPhysicalAssetID(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP OctetStr()){
	//--AgentGen BEGIN=entPhysicalAssetID::entity_mib_entPhysicalAssetID
	//--AgentGen END

}

entity_mib_entPhysicalAssetID::~entity_mib_entPhysicalAssetID()
{

	//--AgentGen BEGIN=entPhysicalAssetID::~entity_mib_entPhysicalAssetID
	//--AgentGen END

}

MibEntryPtr entity_mib_entPhysicalAssetID::clone()
{
	MibEntryPtr other = new entity_mib_entPhysicalAssetID(oid);
	((entity_mib_entPhysicalAssetID*)other)->replace_value(value->clone());
	((entity_mib_entPhysicalAssetID*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=entPhysicalAssetID::clone
	//--AgentGen END
	return other;
}

void entity_mib_entPhysicalAssetID::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalAssetID::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

NS_SNMP OctetStr entity_mib_entPhysicalAssetID::get_state() {
	//--AgentGen BEGIN=entPhysicalAssetID::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void entity_mib_entPhysicalAssetID::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=entPhysicalAssetID::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int entity_mib_entPhysicalAssetID::set(const Vbx& vb)
{
	//--AgentGen BEGIN=entPhysicalAssetID::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int entity_mib_entPhysicalAssetID::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalAssetID::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=entPhysicalAssetID::commit_set_request2
	//--AgentGen END
	return status;
}

void entity_mib_entPhysicalAssetID::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalAssetID::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int entity_mib_entPhysicalAssetID::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalAssetID::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool entity_mib_entPhysicalAssetID::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=entPhysicalAssetID::value_ok
	//--AgentGen END
	return TRUE;
}

int entity_mib_entPhysicalAssetID::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	NS_SNMP Vb vb(req->get_value(ind));
	NS_SNMP OctetStr v;
	vb.get_value(v);
	if (!(((v.len() >= 0) && (v.len() <= 32))))
		 return SNMP_ERROR_WRONG_LENGTH;
	//--AgentGen BEGIN=entPhysicalAssetID::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=entPhysicalAssetID
//--AgentGen END




/**
 *  entPhysicalUris
 *
 * "This object contains identification
 * information about the physical entity.  The object
 * contains URIs; therefore, the syntax of this object
 * must conform to RFC 3986, Section 3.

 * Multiple URIs may be present and are separated by white
 * space characters.  Leading and trailing white space
 * characters are ignored.

 * If no URI identification information is known
 * about the physical entity, the object is not
 * instantiated.  A zero-length octet string may also be
 * returned in this case."
 */
 
entity_mib_entPhysicalUris::entity_mib_entPhysicalUris(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP OctetStr()){
	//--AgentGen BEGIN=entPhysicalUris::entity_mib_entPhysicalUris
	//--AgentGen END

}

entity_mib_entPhysicalUris::~entity_mib_entPhysicalUris()
{

	//--AgentGen BEGIN=entPhysicalUris::~entity_mib_entPhysicalUris
	//--AgentGen END

}

MibEntryPtr entity_mib_entPhysicalUris::clone()
{
	MibEntryPtr other = new entity_mib_entPhysicalUris(oid);
	((entity_mib_entPhysicalUris*)other)->replace_value(value->clone());
	((entity_mib_entPhysicalUris*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=entPhysicalUris::clone
	//--AgentGen END
	return other;
}

void entity_mib_entPhysicalUris::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalUris::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

NS_SNMP OctetStr entity_mib_entPhysicalUris::get_state() {
	//--AgentGen BEGIN=entPhysicalUris::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void entity_mib_entPhysicalUris::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=entPhysicalUris::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int entity_mib_entPhysicalUris::set(const Vbx& vb)
{
	//--AgentGen BEGIN=entPhysicalUris::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int entity_mib_entPhysicalUris::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalUris::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=entPhysicalUris::commit_set_request2
	//--AgentGen END
	return status;
}

void entity_mib_entPhysicalUris::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalUris::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int entity_mib_entPhysicalUris::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalUris::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool entity_mib_entPhysicalUris::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=entPhysicalUris::value_ok
	//--AgentGen END
	return TRUE;
}

int entity_mib_entPhysicalUris::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=entPhysicalUris::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=entPhysicalUris
//--AgentGen END



// Tables


/**
 *  entPhysicalEntry
 *
 * "Information about a particular physical entity.

 * Each entry provides objects (entPhysicalDescr,
 * entPhysicalVendorType, and entPhysicalClass) to help an NMS
 * identify and characterize the entry and objects
 * (entPhysicalContainedIn and entPhysicalParentRelPos) to help
 * an NMS relate the particular entry to other entries in this
 * table."
 */
 
entity_mib_entPhysicalEntry* entity_mib_entPhysicalEntry::instance = 0;

const index_info ind_ENTITY_MIB_EntPhysicalEntry[1] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 }};

entity_mib_entPhysicalEntry::entity_mib_entPhysicalEntry():
   MibTable(oid_ENTITY_MIB_EntPhysicalEntry, ind_ENTITY_MIB_EntPhysicalEntry, 1)
{
	// This table object is a singleton. In order to access it use
	// the static pointer entity_mib_entPhysicalEntry::instance.
	instance = this;

	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalDescr, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalVendorType, READONLY, new NS_SNMP Oid()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalContainedIn, READONLY, new NS_SNMP SnmpInt32()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalClass, READONLY, new NS_SNMP SnmpInt32()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalParentRelPos, READONLY, new NS_SNMP SnmpInt32()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalName, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalHardwareRev, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalFirmwareRev, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalSoftwareRev, READONLY, new NS_SNMP OctetStr()));
	add_col(new entity_mib_entPhysicalSerialNum(col_ENTITY_MIB_EntPhysicalSerialNum));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalMfgName, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalModelName, READONLY, new NS_SNMP OctetStr()));
	add_col(new entity_mib_entPhysicalAlias(col_ENTITY_MIB_EntPhysicalAlias));
	add_col(new entity_mib_entPhysicalAssetID(col_ENTITY_MIB_EntPhysicalAssetID));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalIsFRU, READONLY, new NS_SNMP SnmpInt32()));
	add_col(new DateAndTime(col_ENTITY_MIB_EntPhysicalMfgDate, READONLY, VMODE_DEFAULT)
);
	add_col(new entity_mib_entPhysicalUris(col_ENTITY_MIB_EntPhysicalUris));
	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalUUID, READONLY, new NS_SNMP OctetStr()));
	//--AgentGen BEGIN=entPhysicalEntry::entity_mib_entPhysicalEntry
	//--AgentGen END
}

entity_mib_entPhysicalEntry::~entity_mib_entPhysicalEntry()
{
	//--AgentGen BEGIN=entPhysicalEntry::~entity_mib_entPhysicalEntry
	//--AgentGen END
	// clear singleton reference
	entity_mib_entPhysicalEntry::instance = 0;
}

void entity_mib_entPhysicalEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=entPhysicalEntry::row_added
	//--AgentGen END
}

void entity_mib_entPhysicalEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int entity_mib_entPhysicalEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=entPhysicalEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int entity_mib_entPhysicalEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void entity_mib_entPhysicalEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int entity_mib_entPhysicalEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void entity_mib_entPhysicalEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=entPhysicalEntry::row_delete
	//--AgentGen END
}

void entity_mib_entPhysicalEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=entPhysicalEntry::row_init
	//--AgentGen END
}

void entity_mib_entPhysicalEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=entPhysicalEntry::row_activated
	//--AgentGen END
}

void entity_mib_entPhysicalEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=entPhysicalEntry::row_deactivated
	//--AgentGen END
}

void entity_mib_entPhysicalEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=entPhysicalEntry::update
	//--AgentGen END
}

int entity_mib_entPhysicalEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                                   int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=entPhysicalEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void entity_mib_entPhysicalEntry::set_row(MibTableRow* r, const NS_SNMP OctetStr& p1, const char* p2, long p3
		, long p4, long p5, const NS_SNMP OctetStr& p6
		, const NS_SNMP OctetStr& p7, const NS_SNMP OctetStr& p8, const NS_SNMP OctetStr& p9
		, const NS_SNMP OctetStr& p10, const NS_SNMP OctetStr& p11, const NS_SNMP OctetStr& p12
		, const NS_SNMP OctetStr& p13, const NS_SNMP OctetStr& p14, long p15
		, const NS_SNMP OctetStr& p16, const NS_SNMP OctetStr& p17, const NS_SNMP OctetStr& p18
		)
{
	r->get_nth(0)->replace_value(new NS_SNMP OctetStr(p1));
	r->get_nth(1)->replace_value(new NS_SNMP Oid(p2));
	r->get_nth(2)->replace_value(new NS_SNMP SnmpInt32(p3));
	r->get_nth(3)->replace_value(new NS_SNMP SnmpInt32(p4));
	r->get_nth(4)->replace_value(new NS_SNMP SnmpInt32(p5));
	r->get_nth(5)->replace_value(new NS_SNMP OctetStr(p6));
	r->get_nth(6)->replace_value(new NS_SNMP OctetStr(p7));
	r->get_nth(7)->replace_value(new NS_SNMP OctetStr(p8));
	r->get_nth(8)->replace_value(new NS_SNMP OctetStr(p9));
	r->get_nth(9)->replace_value(new NS_SNMP OctetStr(p10));
	r->get_nth(10)->replace_value(new NS_SNMP OctetStr(p11));
	r->get_nth(11)->replace_value(new NS_SNMP OctetStr(p12));
	r->get_nth(12)->replace_value(new NS_SNMP OctetStr(p13));
	r->get_nth(13)->replace_value(new NS_SNMP OctetStr(p14));
	r->get_nth(14)->replace_value(new NS_SNMP SnmpInt32(p15));
	r->get_nth(15)->replace_value(new NS_SNMP OctetStr(p16));
	r->get_nth(16)->replace_value(new NS_SNMP OctetStr(p17));
	r->get_nth(17)->replace_value(new NS_SNMP OctetStr(p18));
}

//--AgentGen BEGIN=entPhysicalEntry
//--AgentGen END


/**
 *  entLogicalEntry
 *
 * "Information about a particular logical entity.  Entities
 * may be managed by this agent or other SNMP agents (possibly)
 * in the same chassis."
 */
 
entity_mib_entLogicalEntry* entity_mib_entLogicalEntry::instance = 0;

const index_info ind_ENTITY_MIB_EntLogicalEntry[1] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 }};

entity_mib_entLogicalEntry::entity_mib_entLogicalEntry():
   MibTable(oid_ENTITY_MIB_EntLogicalEntry, ind_ENTITY_MIB_EntLogicalEntry, 1)
{
	// This table object is a singleton. In order to access it use
	// the static pointer entity_mib_entLogicalEntry::instance.
	instance = this;

	add_col(new MibLeaf(col_ENTITY_MIB_EntLogicalDescr, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntLogicalType, READONLY, new NS_SNMP Oid()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntLogicalCommunity, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntLogicalTAddress, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntLogicalTDomain, READONLY, new NS_SNMP Oid()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntLogicalContextEngineID, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_ENTITY_MIB_EntLogicalContextName, READONLY, new NS_SNMP OctetStr()));
	//--AgentGen BEGIN=entLogicalEntry::entity_mib_entLogicalEntry
	//--AgentGen END
}

entity_mib_entLogicalEntry::~entity_mib_entLogicalEntry()
{
	//--AgentGen BEGIN=entLogicalEntry::~entity_mib_entLogicalEntry
	//--AgentGen END
	// clear singleton reference
	entity_mib_entLogicalEntry::instance = 0;
}

void entity_mib_entLogicalEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=entLogicalEntry::row_added
	//--AgentGen END
}

void entity_mib_entLogicalEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entLogicalEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int entity_mib_entLogicalEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entLogicalEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=entLogicalEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int entity_mib_entLogicalEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entLogicalEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void entity_mib_entLogicalEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entLogicalEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int entity_mib_entLogicalEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entLogicalEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void entity_mib_entLogicalEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=entLogicalEntry::row_delete
	//--AgentGen END
}

void entity_mib_entLogicalEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=entLogicalEntry::row_init
	//--AgentGen END
}

void entity_mib_entLogicalEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=entLogicalEntry::row_activated
	//--AgentGen END
}

void entity_mib_entLogicalEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=entLogicalEntry::row_deactivated
	//--AgentGen END
}

void entity_mib_entLogicalEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=entLogicalEntry::update
	//--AgentGen END
}

int entity_mib_entLogicalEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                                  int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=entLogicalEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void entity_mib_entLogicalEntry::set_row(MibTableRow* r, const NS_SNMP OctetStr& p1, const char* p2, const NS_SNMP OctetStr& p3
		, const NS_SNMP OctetStr& p4, const char* p5, const NS_SNMP OctetStr& p6
		, const NS_SNMP OctetStr& p7)
{
	r->get_nth(0)->replace_value(new NS_SNMP OctetStr(p1));
	r->get_nth(1)->replace_value(new NS_SNMP Oid(p2));
	r->get_nth(2)->replace_value(new NS_SNMP OctetStr(p3));
	r->get_nth(3)->replace_value(new NS_SNMP OctetStr(p4));
	r->get_nth(4)->replace_value(new NS_SNMP Oid(p5));
	r->get_nth(5)->replace_value(new NS_SNMP OctetStr(p6));
	r->get_nth(6)->replace_value(new NS_SNMP OctetStr(p7));
}

//--AgentGen BEGIN=entLogicalEntry
//--AgentGen END


/**
 *  entLPMappingEntry
 *
 * "Information about a particular logical-entity-to-physical-
 * equipment association.  Note that the nature of the
 * association is not specifically identified in this entry.
 * It is expected that sufficient information exists in the
 * MIB modules used to manage a particular logical entity to
 * infer how physical component information is utilized."
 */
 
entity_mib_entLPMappingEntry* entity_mib_entLPMappingEntry::instance = 0;

const index_info ind_ENTITY_MIB_EntLPMappingEntry[2] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 },
	 { sNMP_SYNTAX_INT, FALSE, 1, 1 }};

entity_mib_entLPMappingEntry::entity_mib_entLPMappingEntry():
   MibTable(oid_ENTITY_MIB_EntLPMappingEntry, ind_ENTITY_MIB_EntLPMappingEntry, 2)
{
	// This table object is a singleton. In order to access it use
	// the static pointer entity_mib_entLPMappingEntry::instance.
	instance = this;

	add_col(new MibLeaf(col_ENTITY_MIB_EntLPPhysicalIndex, READONLY, new NS_SNMP SnmpInt32()));
	//--AgentGen BEGIN=entLPMappingEntry::entity_mib_entLPMappingEntry
	//--AgentGen END
}

entity_mib_entLPMappingEntry::~entity_mib_entLPMappingEntry()
{
	//--AgentGen BEGIN=entLPMappingEntry::~entity_mib_entLPMappingEntry
	//--AgentGen END
	// clear singleton reference
	entity_mib_entLPMappingEntry::instance = 0;
}

void entity_mib_entLPMappingEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=entLPMappingEntry::row_added
	//--AgentGen END
}

void entity_mib_entLPMappingEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entLPMappingEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int entity_mib_entLPMappingEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entLPMappingEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=entLPMappingEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int entity_mib_entLPMappingEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entLPMappingEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void entity_mib_entLPMappingEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entLPMappingEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int entity_mib_entLPMappingEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entLPMappingEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void entity_mib_entLPMappingEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=entLPMappingEntry::row_delete
	//--AgentGen END
}

void entity_mib_entLPMappingEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=entLPMappingEntry::row_init
	//--AgentGen END
}

void entity_mib_entLPMappingEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=entLPMappingEntry::row_activated
	//--AgentGen END
}

void entity_mib_entLPMappingEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=entLPMappingEntry::row_deactivated
	//--AgentGen END
}

void entity_mib_entLPMappingEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=entLPMappingEntry::update
	//--AgentGen END
}

int entity_mib_entLPMappingEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                                    int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=entLPMappingEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void entity_mib_entLPMappingEntry::set_row(MibTableRow* r, long p1)
{
	r->get_nth(0)->replace_value(new NS_SNMP SnmpInt32(p1));
}

//--AgentGen BEGIN=entLPMappingEntry
//--AgentGen END


/**
 *  entAliasMappingEntry
 *
 * "Information about a particular binding between a
 * logical entity/physical component pair and an external
 * identifier.  Each logical entity/physical component pair
 * may be associated with one alias mapping.
 * The logical entity index may also be used as
 * a 'wildcard' (refer to the entAliasLogicalIndexOrZero object
 * DESCRIPTION clause for details.)

 * Note that only entPhysicalIndex values that represent
 * physical ports (i.e., associated entPhysicalClass value is
 * 'port(10)') are permitted to exist in this table."
 */
 
entity_mib_entAliasMappingEntry* entity_mib_entAliasMappingEntry::instance = 0;

const index_info ind_ENTITY_MIB_EntAliasMappingEntry[2] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 },
	 { sNMP_SYNTAX_INT, FALSE, 1, 1 }};

entity_mib_entAliasMappingEntry::entity_mib_entAliasMappingEntry():
   MibTable(oid_ENTITY_MIB_EntAliasMappingEntry, ind_ENTITY_MIB_EntAliasMappingEntry, 2)
{
	// This table object is a singleton. In order to access it use
	// the static pointer entity_mib_entAliasMappingEntry::instance.
	instance = this;

	add_col(new MibLeaf(col_ENTITY_MIB_EntAliasMappingIdentifier, READONLY, new NS_SNMP Oid()));
	//--AgentGen BEGIN=entAliasMappingEntry::entity_mib_entAliasMappingEntry
	//--AgentGen END
}

entity_mib_entAliasMappingEntry::~entity_mib_entAliasMappingEntry()
{
	//--AgentGen BEGIN=entAliasMappingEntry::~entity_mib_entAliasMappingEntry
	//--AgentGen END
	// clear singleton reference
	entity_mib_entAliasMappingEntry::instance = 0;
}

void entity_mib_entAliasMappingEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=entAliasMappingEntry::row_added
	//--AgentGen END
}

void entity_mib_entAliasMappingEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entAliasMappingEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int entity_mib_entAliasMappingEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entAliasMappingEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=entAliasMappingEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int entity_mib_entAliasMappingEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entAliasMappingEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void entity_mib_entAliasMappingEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entAliasMappingEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int entity_mib_entAliasMappingEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entAliasMappingEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void entity_mib_entAliasMappingEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=entAliasMappingEntry::row_delete
	//--AgentGen END
}

void entity_mib_entAliasMappingEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=entAliasMappingEntry::row_init
	//--AgentGen END
}

void entity_mib_entAliasMappingEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=entAliasMappingEntry::row_activated
	//--AgentGen END
}

void entity_mib_entAliasMappingEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=entAliasMappingEntry::row_deactivated
	//--AgentGen END
}

void entity_mib_entAliasMappingEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=entAliasMappingEntry::update
	//--AgentGen END
}

int entity_mib_entAliasMappingEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                                       int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=entAliasMappingEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void entity_mib_entAliasMappingEntry::set_row(MibTableRow* r, const char* p1)
{
	r->get_nth(0)->replace_value(new NS_SNMP Oid(p1));
}

//--AgentGen BEGIN=entAliasMappingEntry
//--AgentGen END


/**
 *  entPhysicalContainsEntry
 *
 * "A single container/'containee' relationship."
 */
 
entity_mib_entPhysicalContainsEntry* entity_mib_entPhysicalContainsEntry::instance = 0;

const index_info ind_ENTITY_MIB_EntPhysicalContainsEntry[2] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 },
	 { sNMP_SYNTAX_INT, FALSE, 1, 1 }};

entity_mib_entPhysicalContainsEntry::entity_mib_entPhysicalContainsEntry():
   MibTable(oid_ENTITY_MIB_EntPhysicalContainsEntry, ind_ENTITY_MIB_EntPhysicalContainsEntry, 2)
{
	// This table object is a singleton. In order to access it use
	// the static pointer entity_mib_entPhysicalContainsEntry::instance.
	instance = this;

	add_col(new MibLeaf(col_ENTITY_MIB_EntPhysicalChildIndex, READONLY, new NS_SNMP SnmpInt32()));
	//--AgentGen BEGIN=entPhysicalContainsEntry::entity_mib_entPhysicalContainsEntry
	//--AgentGen END
}

entity_mib_entPhysicalContainsEntry::~entity_mib_entPhysicalContainsEntry()
{
	//--AgentGen BEGIN=entPhysicalContainsEntry::~entity_mib_entPhysicalContainsEntry
	//--AgentGen END
	// clear singleton reference
	entity_mib_entPhysicalContainsEntry::instance = 0;
}

void entity_mib_entPhysicalContainsEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=entPhysicalContainsEntry::row_added
	//--AgentGen END
}

void entity_mib_entPhysicalContainsEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalContainsEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int entity_mib_entPhysicalContainsEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=entPhysicalContainsEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=entPhysicalContainsEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int entity_mib_entPhysicalContainsEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalContainsEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void entity_mib_entPhysicalContainsEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalContainsEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int entity_mib_entPhysicalContainsEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=entPhysicalContainsEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void entity_mib_entPhysicalContainsEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=entPhysicalContainsEntry::row_delete
	//--AgentGen END
}

void entity_mib_entPhysicalContainsEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=entPhysicalContainsEntry::row_init
	//--AgentGen END
}

void entity_mib_entPhysicalContainsEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=entPhysicalContainsEntry::row_activated
	//--AgentGen END
}

void entity_mib_entPhysicalContainsEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=entPhysicalContainsEntry::row_deactivated
	//--AgentGen END
}

void entity_mib_entPhysicalContainsEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=entPhysicalContainsEntry::update
	//--AgentGen END
}

int entity_mib_entPhysicalContainsEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                                           int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=entPhysicalContainsEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void entity_mib_entPhysicalContainsEntry::set_row(MibTableRow* r, long p1)
{
	r->get_nth(0)->replace_value(new NS_SNMP SnmpInt32(p1));
}

//--AgentGen BEGIN=entPhysicalContainsEntry
//--AgentGen END

// Notifications
#ifdef _SNMPv3


/**
 *  entConfigChange
 *
 * "An entConfigChange notification is generated when the value
 * of entLastChangeTime changes.  It can be utilized by an NMS
 * to trigger logical/physical entity table maintenance polls.

 * An agent should not generate more than one entConfigChange
 * 'notification-event' in a given time interval (five seconds
 * is the suggested default).  A 'notification-event' is the
 * transmission of a single trap or inform PDU to a list of
 * notification destinations.

 * If additional configuration changes occur within the
 * throttling period, then notification-events for these
 * changes should be suppressed by the agent until the current
 * throttling period expires.  At the end of a throttling
 * period, one notification-event should be generated if any
 * configuration changes occurred since the start of the
 * throttling period.  In such a case, another throttling
 * period is started right away.







 * An NMS should periodically check the value of
 * entLastChangeTime to detect any missed entConfigChange
 * notification-events, e.g., due to throttling or transmission
 * loss."
 */
 
entity_mib_entConfigChange::entity_mib_entConfigChange(): NotificationType()
{
	//--AgentGen BEGIN=entConfigChange::entity_mib_entConfigChange
	//--AgentGen END
}

entity_mib_entConfigChange::~entity_mib_entConfigChange()
{
	//--AgentGen BEGIN=entConfigChange::~entity_mib_entConfigChange
	//--AgentGen END
}

int entity_mib_entConfigChange::notify(const NS_SNMP OctetStr& context, Vbx* vbs, int sz)
{
	//--AgentGen BEGIN=entConfigChange::generate
	//--AgentGen END
#ifndef _NO_LOGGING
#endif
	return Mib::instance->notify(context, oid_ENTITY_MIB_EntConfigChange, vbs, sz);
}

//--AgentGen BEGIN=entConfigChange
//--AgentGen END
#endif

// Group
entity_mib::entity_mib():
   MibGroup("1.3.6.1.2.1.47", "entity_mib")
{
	//--AgentGen BEGIN=entity_mib::entity_mib
	//--AgentGen END
	add(new entity_mib_entLastChangeTime());
	add(new entity_mib_entPhysicalEntry());
	add(new entity_mib_entLogicalEntry());
	add(new entity_mib_entLPMappingEntry());
	add(new entity_mib_entAliasMappingEntry());
	add(new entity_mib_entPhysicalContainsEntry());
	//--AgentGen BEGIN=entity_mib::entity_mib:post
	//--AgentGen END
}

//--AgentGen BEGIN=entity_mib
//--AgentGen END



//--AgentGen BEGIN=_CLASSES
//--AgentGen END


#ifdef AGENTPP_NAMESPACE
}
#endif


//--AgentGen BEGIN=_END
//--AgentGen END

#endif

